

Application create: #FBaseCluster with:
        (#( Kernel)
            collect: [:each | Smalltalk at: each ifAbsent: [
                self error: 'Not all of the prerequisites are loaded']])!

FBaseCluster becomeDefault!
Application subclass: #FBaseCluster
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!
Object subclass: #TmClassManager
    instanceVariableNames: 'classCol classDict clauseClassCol clauseClassDict '
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!
Object subclass: #TmObject
    instanceVariableNames: ''
    classVariableNames: 'ClassManager IsAbstract '
    poolDictionaries: ''!

FBaseCluster becomeDefault!
TmObject subclass: #Clause
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!
Clause subclass: #AnyClause
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!
Clause subclass: #IdClause
    instanceVariableNames: 'id '
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!
IdClause subclass: #ClassIdClause
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!
Clause subclass: #NameClause
    instanceVariableNames: 'name '
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!
NameClause subclass: #ClassnameClause
    instanceVariableNames: ''
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!
Clause subclass: #PropClause
    instanceVariableNames: 'isAbstract '
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!
Object subclass: #TmPair
    instanceVariableNames: 'obj1 obj2 '
    classVariableNames: ''
    poolDictionaries: ''!

FBaseCluster becomeDefault!

!AnyClause class publicMethods !

isAbstract
	^false!

root
	^TmObject! !


!AnyClause publicMethods !

adaptToClass: aClass
	"do nothing - any clause fits any class"! !


!ClassIdClause class publicMethods !

isAbstract
	^false!

root
	^TmObject! !


!ClassIdClause publicMethods !

adaptToClass: aClass
	id := aClass symbol! !


!ClassnameClause class publicMethods !

isAbstract
	^false!

root
	^TmObject! !


!ClassnameClause publicMethods !

adaptToClass: aClass
	name := aClass name! !


!Clause class publicMethods !

root
	self subclassResponsibility! !


!Clause publicMethods !

adaptToClass: aClass
	self subclassResponsibility!

matches: aClause
	"comparison by default an equality check"
	^ ( self class ) == ( aClause class )!

root
	^self class root! !


!IdClause class publicMethods !

new: aSymbol
	^super new initialize: aSymbol! !


!IdClause publicMethods !

id
	^id!

initialize: aSymbol
	id := aSymbol.!

matches: aClause
	^ ( super matches: aClause ) & ( ( self id ) = ( aClause id ) )! !


!NameClause class publicMethods !

new: aString
	^super new initialize: aString! !


!NameClause publicMethods !

initialize: aString
	name := aString!

matches: aClause
	^ ( super matches: aClause ) & ( ( self name ) = ( aClause name ) )!

name
	^name! !


!PropClause class publicMethods !

isAbstract
	^false!

new: isAbstract
	^super new initialize: isAbstract!

root
	^TmObject! !


!PropClause publicMethods !

adaptToClass: aClass
	isAbstract := aClass isAbstract!

initialize: abstract
	isAbstract := abstract!

matches: aClause
	^ ( super matches: aClause ) & ( ( self prop ) == ( aClause prop ) )!

prop
	^isAbstract! !


!TmClassManager class publicMethods !

new
	^super new initialize! !


!TmClassManager publicMethods !

initClassDict

	classDict := Dictionary new.

	classCol do: [ :aClass |
		| aClauseDict |

		aClauseDict := Dictionary new.
		classDict at: ( aClass symbol ) put: aClauseDict.

		clauseClassCol do: [ :aClauseClass |
			| aRootclass |

			aRootclass := aClauseClass root.

			( aClass == aRootclass ) | ( aClass inheritsFrom: aRootclass ) ifTrue: [
				| aClause |

				aClause := aClauseClass new adaptToClass: aClass.
				aClauseDict at: ( aClauseClass symbol ) put: aClause. ] ] ]
!

initClauseClassDict

	clauseClassDict := Dictionary new.

	clauseClassCol do: [ :aClauseClass |

		( aClauseClass inheritsFrom: IdClause ) ifTrue: [
			| aClassCol aClassDict |

			aClassDict := Dictionary new.
			aClassCol := OrderedCollection new.

			aClauseClass root getFullClassCol: aClassCol.

			aClassCol do: [ :aClass |
				| aClause |

				aClause := aClauseClass new adaptToClass: aClass.
				aClassDict at: ( aClause id ) put: aClass ].

			clauseClassDict at: ( aClauseClass symbol ) put: aClassDict ] ]
!

initialize

	classCol := OrderedCollection new.
	TmObject getFullClassCol: classCol.

	clauseClassCol := OrderedCollection new.
	Clause getConcreteClassCol: clauseClassCol.

	self initClassDict.
	self initClauseClassDict.
!

lookupByIdClause: anIdClause
	| aClassDict |

	aClassDict := clauseClassDict at: ( anIdClause class symbol ).
	^ aClassDict at: ( anIdClause id ).!

matchesClause: aClause for: aClass
	| aClauseDict bClause |

	aClauseDict := classDict at: ( aClass symbol ).
	bClause := aClauseDict at: ( aClause class symbol ).

	^ aClause matches: bClause! !


!TmObject class publicMethods !

classManager
	^ClassManager!

classManager: aManager
	ClassManager := aManager!

cleanUp
	"dangerous operation!!!! used to free memory due to
	garbage collector problems with visual age 2.0!!!!
	remove in future system releases!!!!"

	| classCol | 
	
	classCol := OrderedCollection new.
	TmObject getFullClassCol: classCol.

	classCol do: [ :class |
		class allInstances do: [ :instance | 
			instance become: nil ] ]!

createByIdClause: aClause
	| aClass |

	aClass := self classManager lookupByIdClause: aClause.

	( aClass = self ) | ( aClass inheritsFrom: self )
	ifTrue: [
		^aClass new ]
	ifFalse: [
		"configuration error: class requested that is not subclass
		of starting point."
		self halt ]
	!

getClassByIdClause: aClause
	| aClass |

	aClass := self classManager lookupByIdClause: aClause.

	( aClass = self ) | ( aClass inheritsFrom: self )
	ifTrue: [
		^aClass ]
	ifFalse: [
		"configuration error: class requested which isnt
		subclass of starting class."
		self halt ]
	!

getClassCol: aClassCol byClause: aClause

	( self matchesClause: aClause ) ifTrue: [
		aClassCol add: self ].

	self subclasses do: [ :class | 
		class getClassCol: aClassCol byClause: aClause ]!

getConcreteClassCol: classCol

	self isAbstract ifFalse: [
		classCol add: self ].

	self subclasses do: [ :class |
		class getConcreteClassCol: classCol ]
!

getFullClassCol: classCol
	classCol add: self.
	self subclasses do: [ :class |
		class getFullClassCol: classCol ]
!

isAbstract
	^true!

matchesClause: aClause
	^self classManager matchesClause: aClause for: self
!

matchesSpec: aSpec
! !


!TmObject publicMethods !

changed: aSymbol
	| anEvObject |

	anEvObject := TmPair new: aSymbol with: self.
	super changed: anEvObject.
	!

update: aPair
	self update: ( aPair obj1 ) from: ( aPair obj2 )!

update: aSymbol from: anObject
	"do nothing by default, that is allow subclasses to call
	this operation without syntax error."
! !


!TmPair class publicMethods !

new: anObj1 with: anObj2
	^super new initialize: anObj1 with: anObj2
! !


!TmPair publicMethods !

initialize: anObj1 with: anObj2
	obj1 := anObj1.
	obj2 := anObj2.!

obj1
	^obj1!

obj2
	^obj2! !

